/*

 */


#include <stdlib.h>
#include <stdio.h>
#include "gsm_internal.h"
#include "libgsmcom.h"
#include "gsm_sms.h"





GSM_SCHEDULED_CB(gsm_sched_check_sms_state);
GSM_SCHEDULED_CB(gsm_sched_check_sms_state0);
GSM_SCHEDULED_CB(gsm_sched_check_sms_state1);

static int  gsm_send_sms_body(struct gsm_span *span);



int check_num_is_digit(const char *num)
{
    const char tab[]="0123456789*#";
    if(!num)
        return 1;
    int len = strlen(num);
    int i = 0;
    
    if(num[0] != '+' && !strchr(tab,num[0]))
        return 1;
    
    for(i = 1; i<len; i++)
    {
        if(!strchr(tab,num[i]))
            return 1;
    }
    return 0;
}
//long sms total_num must change in app
int gsm_encode_pdu_body(struct gsm_span *span, struct gsm_sms_event_data *sms)
{
    int len = 0;
    int pdu_header_len = 0;
    unsigned char pdu_msg[GSM_MAX_SMS_LEN] = {0}; //LAST COPY TO PDU
    unsigned char *buf = pdu_msg; //ָ룬ֱpdu_msg,h
    unsigned char utf8_data[GSM_MAX_SMS_LEN] = {0};
   // int out_data_len = 0;
    int udh_len = 0;
    unsigned char *udh_loc = NULL;
    int i = 0;
    
    if(!span || !sms)
        return 1;
   
     if((strlen(sms->smsc)>0)&&check_num_is_digit(sms->smsc))
         return 1;
     
     //last convert to strings,do this item,and point to new 
     if(gsm_encode_pdu_smsc(sms->smsc, &buf,  &len))
        return 1;

     
     //all pdu_data_len ,in front of the pdu data
     //body_data_len at+cmgs=
     // CSMS ȣΪȥSCAֽڳ
     pdu_header_len = len;
    //pdu_header_len SCAĳ
      
     //why not vp.value ,only vp.type **buf change the buf point
      gsm_encode_pdu_submit_ref(0x31, 0x00, &buf, &len ); 
     //
     if (gsm_encode_pdu_to_num(sms->to, &buf, &len))
        return 1;
     /*
     00 Эʶ(TP-PID) ͨGSMͣ㵽㷽ʽ
    00 ûϢ뷽ʽ(TP-DCS) 7-bit
    00 Ч(TP-VP) 5

     */
     gsm_encode_pdu_pid(sms->pid, &buf, &len);

     //jwj add 
      memcpy(utf8_data, sms->content.message, sizeof(utf8_data));
     //utf8
     //if(gsm_decode_pdu_content(utf8_data, &out_data_len, &sms->content))
     //    return 1;

     //the normal use 7bit 
     gsm_encode_pdu_dcs(sms->dcs, &buf, &len);

     gsm_encode_pdu_vp(0x00, &buf, &len);

     udh_loc = buf;
     
     *udh_loc =  sms->content.msg_len;
     
     //7bit long sms is different
     switch (sms->dcs) 
    {
               case 0:
               {
                               unsigned char *p_udh_loc = udh_loc + 1;
                               //int  content_len = udh_len;
                               int utf8_len = strlen((char *)utf8_data);
                                /* Convert the length into septets */
                               int ret =0;
                               int offset = octet_to_septet(udh_len);//8-->7
                             
                                ret = gsmEncode7bit(utf8_data, &p_udh_loc, utf8_len,offset);
                                if(ret)
                                    return 1;
                                
                                *udh_loc = octet_to_septet(udh_len) + utf8_len; //this is body_data len
                     
                                len += septet_to_octet(utf8_len + octet_to_septet(udh_len)) - udh_len;
              
                                len++;

               }
               break;
             case 8:
             {           //
                         len += sms->content.msg_len + udh_len+1;
                         //code_convert((char*)"UTF-8", (char*)"UCS-2",( char*) utf8_data, utf8_len, ( char*)&buf[len], 1024);                   
                         break;     
             }
             break;
            default:
                       return 1;
        }

       sms->pdu_len = len - pdu_header_len; //at+cmgs
       //pdu_header_len is smsc len
       //udl_len is pdu data len 8bit two hex
        /*  Convert into string representation */
        //org message is store content,but now store more info
        //memset(sms->data.content.message, 0, sizeof(sms->data.content.message));
        memset(sms->body, 0, sizeof(sms->body));

       //pdu_header_len += udh_len;
        for (i = 0; i < (len - sms->content.msg_len ) ; i++) {
                sprintf((char *)&sms->body[i*2], "%02x", (0xFF) & pdu_msg[i]);
        }
     
        memcpy((char*)(sms->body+i*2), utf8_data, sms->content.msg_len*2);
         //snprintf((char *)&sms->body[i*2], "%x", (0xFF) & pdu_msg[i]);
        //gsmBytes2String
        sms->content.msg_len= len*2;

     return 0;
}

static int  gsm_send_sms_body(struct gsm_span *span)
{
    
   char cmd[1024] = {0};
   struct gsm_sms_event_data *sms = NULL;
   int len, write_len;
   

    if(!span)
        return 1;
    sms = &span->smss;
    
    sms->msg_len = strlen(sms->body);
    sms->send_len = 0; 
    while (sms->send_len < sms->msg_len) {
                memset(cmd, 0, sizeof(cmd));
                len = sms->msg_len - sms->send_len;
                if (len <= 0) {
                        break; //
                }

                if (len > sizeof(cmd)) {
                        len = sizeof(cmd) -1;
                }

                memcpy(cmd, &sms->body[sms->send_len], len);//
                write_len = gsm_span_write(span->span_id, cmd, len);//

                sms->send_len += write_len;

                if (write_len <= 0) {
                        /* Some lower level queue is full  */
                        gsm_log(GSM_LOG_WARNING," sendsms body but fail\n");
                        break;//jwj change 2012-7-1
                }
        }
        

    gsm_set_sms_state(span, GSM_SMS_STATE_SEND_END);
    return 0;
}




GSM_SCHEDULED_CB(gsm_sched_check_sms_state)
{
    struct gsm_span *span = (struct gsm_span*)data;

    if(!span)
        return 1;
    if(span->smss.stats == GSM_SMS_STATE_SEND_HEADER)
    {
        gsm_log(GSM_LOG_WARNING, "gsm_sched_check_sms_state and set fail\n");
        gsm_set_sms_state(span, GSM_SMS_STATE_FAIL);
    }
    return 0;
}

GSM_SCHEDULED_CB(gsm_sched_check_sms_state0)
{
    struct gsm_span *span = (struct gsm_span*)data;

    if(!span)
        return 1;
    if(span->smss.stats == GSM_SMS_STATE_START)
    {
        gsm_log(GSM_LOG_WARNING, "gsm_sched_check_sms_state and set fail\n");
        gsm_set_sms_state(span, GSM_SMS_STATE_FAIL);
    }
    return 0;
}


GSM_SCHEDULED_CB(gsm_sched_check_sms_state1)
{
    struct gsm_span *span = (struct gsm_span*)data;

    if(!span)
        return 1;
    if(span->smss.stats == GSM_SMS_STATE_SEND_END)
    {
        gsm_log(GSM_LOG_WARNING, "gsm_sched_check_sms_state and set fail\n");
        gsm_set_sms_state(span, GSM_SMS_STATE_FAIL);
    }
    return 0;
}

int gsm_set_sms_state(struct gsm_span *span, gsm_sms_state_t  newstate)
{
    //struct gsm_sms_data *tmp = NULL;
    // char *cmd;
     char send_cmd[50] = {0};
     int res =0;
    

     if(!span)
        return 1;
     
    span->smss.stats= newstate;

    switch (newstate)//may be ״̬ж
    {
        case GSM_SMS_STATE_INIT:
            //  뵽sms queue
            
            break;
        case GSM_SMS_STATE_READY://encode body  sms_queue
       {    //ENCODE_PDU_BODY
       
            gsm_log(GSM_LOG_WARNING, "sendsms state=GSM_SMS_STATE_READY\n");
           if( span->smss.gsm_sms_mode)
            {     //this is control the len 160 is the max len
                  //long sms can div and insert to sms
                  //sms->msg_len = sms->data.content.msg_len;
            }
           else
           {
                res =  gsm_encode_pdu_body(span, &span->smss);
           }
           if(res)
           {
                gsm_log(GSM_LOG_WARNING, "sendsms gsm_encode_pdu_body fail\n");
                gsm_set_sms_state(span, GSM_SMS_STATE_FAIL);
           }
           else
                gsm_set_sms_state(span, GSM_SMS_STATE_START);
       }   
       break;
       
        case GSM_SMS_STATE_START:   //change cmgf mode  sms_queue
        {   //GET AT+CMGF

            gsm_log(GSM_LOG_WARNING, "sendsms state=GSM_SMS_STATE_START\n");
            if(span->smss.gsm_sms_mode)//txt mode
            {
                {
                    snprintf(send_cmd, sizeof(send_cmd), "%s%s", "AT+CMGF=1",GSM_CMD_END);
                }
            }
            else
            {
                snprintf(send_cmd, sizeof(send_cmd), "%s%s", "AT+CMGF=0",GSM_CMD_END);        

            }//gsm_cmd_enqueue is very import
             res = gsm_write_cmd(span, send_cmd, strlen(send_cmd));
             span->timer = gsm_sched_add(&span->sched_queue, 3000, gsm_sched_check_sms_state0, (void*)span);
             //gsm_set_sms_state(span, GSM_SMS_STATE_SEND_HEADER);
        }
         break;
        case GSM_SMS_STATE_SEND_HEADER://cmd queue
        {
            gsm_log(GSM_LOG_WARNING, "sendsms state=GSM_SMS_STATE_SEND_HEADER\n");

            if(span->smss.gsm_sms_mode)
            {
                snprintf(send_cmd, sizeof(send_cmd), "%s\"%s\"%s", "AT+CMGS=",span->smss.to,GSM_CMD_END);
            }
            else
            {
                snprintf(send_cmd, sizeof(send_cmd), "%s%d%s", "AT+CMGS=", span->smss.pdu_len,GSM_CMD_END);
                
            }//this is null,and ret '>'  so the cmd_busy not clear
             gsm_sched_del(&span->sched_queue, span->timer);
            res = gsm_write_cmd(span, send_cmd, strlen(send_cmd));
            span->timer = gsm_sched_add(&span->sched_queue, 6000, gsm_sched_check_sms_state, (void*)span);

        }
        break;
        case GSM_SMS_STATE_SEND_BODY:
        {
            gsm_log(GSM_LOG_WARNING, "sendsms state=GSM_SMS_STATE_SEND_BODY\n");
            gsm_sched_del(&span->sched_queue, span->timer);
            gsm_send_sms_body(span);//have to enqueue cmd send over in 10s
            
        }
        break;
        case GSM_SMS_STATE_SEND_END:   //CTROL+Z  send end
        {
               sprintf(send_cmd, "%c\r\n", 0x1a);
               gsm_log(GSM_LOG_WARNING,"sendsms and send end char\n");
               res = gsm_write_cmd(span, send_cmd, strlen(send_cmd));
                span->timer = gsm_sched_add(&span->sched_queue, 9000, gsm_sched_check_sms_state1, (void*)span);
               // gsm_span_write(span->span_id, cmd, len);
               //len=3 

        }
        break;
        case GSM_SMS_STATE_COMPLETE: //send ok change to pdu mode
        {    
              span->smss.status.success = 1;
              if (span->smss.gsm_sms_mode && (!span->smss.queue_flag)&&(!span->smss.long_flag))
              {
                
                    {
                         //snprintf(send_cmd, sizeof(send_cmd), "%s%s", "AT+CMGF=0",GSM_CMD_END);
                         //res = gsm_write_cmd(span, send_cmd, strlen(send_cmd));
                         sleep(1);
                    }
                   
              }
              gsm_sched_del(&span->sched_queue, span->timer);
             gsm_log(GSM_LOG_WARNING,"sendsms ok\n"); 
            gsm_sms_report(span->span_id, &span->smss);
            memset(&span->smss, 0, sizeof(span->smss));
            //span->smss[sms->data.smsid] = NULL;
           
        }
        break;
        case GSM_SMS_STATE_FAIL:
        {   
             snprintf(send_cmd, sizeof(send_cmd), "%c", 0x1b);
             res = gsm_write_cmd(span, send_cmd, strlen(send_cmd));
             span->smss.status.success = 0;
             gsm_sms_report(span->span_id, &span->smss);
            
             //span->smss[sms->data.smsid] = NULL;
             memset(&span->smss, 0, sizeof(span->smss));
             gsm_sched_del(&span->sched_queue, span->timer);
              gsm_log(GSM_LOG_WARNING,"sendsms fail and destory and send esc state=%d\n",span->smss.stats);
        }
        break;
        default:
            return 1;
    }
    return 0;

}





#if 0
static int gsm_sms_find_smsid(struct gsm_span *span)
{
     int i = 0;
     
     if(!span)
        return GSM_MAX_SMSS_IN_SPAN;
     
     for(i=0; i< GSM_MAX_SMSS_IN_SPAN; i++)
     {
         if(span->smss[i] == NULL)
            return i;
     }

     return i;
}
#endif



 int gsm_sms_req(unsigned int span_id,  struct gsm_sms_event_data  *sms_data)
{
    struct gsm_span *span = NULL;
//    int i = 0;
    
    if(span_id <= 0 || span_id > GSM_MAX_SPANS)
        return 1;

    span = gsm_get_span( span_id);

    if(!span || !sms_data)
        return 1;

     if(span->span_state < GSM_SPAN_STATE_RUNNING)
         return 1;
       
    //jwj add 2012-6-27
   //add to smss queue
    memcpy(&span->smss, sms_data, sizeof(span->smss));
    //jwj add 2012-6-19
    if(span->smss.stats >0 || (span->calls.newstate > 0))
    {
        gsm_log(GSM_LOG_WARNING, "gsm module spanno=%d is busy\n",span->span_id);
        return 1;
    }
    gsm_set_sms_state(span, GSM_SMS_STATE_READY);
   return 0;
}


 int gsm_parse_cmd(char * buf, char token,char *cmd[],  int len)
{
    //char tmp[GSM_MAX_ATCMD_LEN] = {0};
    char *p = NULL;
    int i= 0;
     
   
    p = buf;
    
    if(!p)
        return i;
    
    if( (p = strchr(p, token)))
    {
         cmd[i] = buf;
        *p++ = '\0';
         i++;
         cmd[i] = p;

        if(i >= len)
            return i;
       
    }
    return i;
}

 int gsm_handle_incoming_txt_sms(struct gsm_span *span, char *from, char *scts, char *content)
 {
   struct gsm_sms_event_data data;
   int num = 0;

   char *cmd[3];//sizeof cmd  10*4=40

    if(!span || !from || !scts || !content)
        return 1;
   
    memset(&data, 0, sizeof(struct gsm_sms_event_data));
    
    memcpy(data.from, from, sizeof(data.from));

   // num = gsm_parse_token_num(scts,  ','); 

    num =  gsm_parse_cmd(scts , ',', cmd, gsm_array_len(cmd));
    if(num !=  1)
        return 1;
    
    else 
    {
        if ( sscanf(cmd[0],"%d/%d/%d",&data.timestamp.year, &data.timestamp.month, &data.timestamp.day) != 3 )
            return 1;

        if ( sscanf(cmd[1],"%d:%d:%d+%d",&data.timestamp.hour, &data.timestamp.minute, &data.timestamp.second, &data.timestamp.timezone) != 4 )
            return 1;

    }

    memcpy(data.content.message, content, GSM_MAX_CONTENT_LEN);

    data.gsm_sms_mode = 1;
    if(g_interface.gsm_sms_ind)
        g_interface.gsm_sms_ind(span->span_id, &data);
    
    return 0;   
 }


int  gsm_handle_incoming_pdu_sms(struct gsm_span *span, char *content, int len)
{
    struct gsm_sms_event_data data; //
   // int num = 0;
    char pdu_msg[GSM_MAX_ATCMD_LEN] = {0};
    char raw_msg[GSM_MAX_ATCMD_LEN] = {0};
    char *p = NULL;
    int msg_len = 0;
    char numbuf[GSM_CALL_NUM_LEN] = {0};
    int num_len = 0;
    int from_len = 0;
    unsigned char first_oct = 0;
    unsigned char  tp_udl,udhl;
    unsigned char type,smsc_type;
    unsigned char plan,smsc_plan;
    char seq = 0;
    
    memset(&data, 0, sizeof(struct gsm_sms_event_data));
    
    if(!span || !content)
    {
        gsm_log(GSM_LOG_WARNING,"gsm_handle_incoming_pdu_sms but have no span or content\n");
        return 1;
    }
    memcpy(pdu_msg, content, sizeof(pdu_msg));
    
    p = pdu_msg;
    
    p = pdu_get_smsc_len(p, (char*)&num_len);
    if(num_len > 0)
    {
        p = pdu_get_addr_type(p, (char*)&smsc_type,(char*)&smsc_plan);
        p = pdu_get_addr_num(p, num_len, numbuf,0);
        gsm_reverse_num(numbuf, data.smsc ,1);

    }
    
    p = pdu_get_first_oct(p, &first_oct);
    p = pdu_get_oa_len(p,(char *)&from_len);
    if (from_len> 0) 
    {
         p = pdu_get_addr_type(p, (char*)&type,(char*)&plan);
         //918613723751223f
         p = pdu_get_addr_num(p, from_len, numbuf,1);
         gsm_reverse_num(numbuf, data.from, 1);

   }

   p = pdu_get_pid(p,(char *)&data.pid);
   
   p = pdu_decode_ud_dcs(p,  &data.dcs);
   p = pdu_get_timestamp(p, &data.timestamp);
   
   //gsm_reverse_string(pdu_msg->timestamp,timestamp);
   
   p = pdu_get_ud_len(p, &tp_udl);//get user data len
   
   if(first_oct & 0x40)//get inhead len
   {
        gsm_log(GSM_LOG_WARNING, "recv newsms but have more head\n");
        p = pdu_decode_udh(p, &udhl, &seq);
   }
   
   msg_len =tp_udl- udhl ;
   //16--to --10 len div/2
   gsm_string2byte(p, msg_len, (unsigned char*)raw_msg);

   switch( data.dcs )
   {
        case 0:  
            if(msg_len)
            gsm_to8Bit( (unsigned char*)raw_msg, (unsigned char*) data.content.message, msg_len, seq);//8bit now
            break;
        case 4:
            
            break;
        case 8:
            if(msg_len)
           {
                memset(data.content.message, 0 , sizeof(data.content.message));
                sms_decode_language(raw_msg, msg_len, data.content.message, 512, 0);
                msg_len = 10;
            }
            break;
        default:
            break;
   }
   //ast_copy_string(pdu_msg->ud,p,sizeof(pdu_msg->ud)); 

   data.content.charset = GSM_SMS_CONTENT_ENCRYPT_NONE;

    data.gsm_sms_mode = 0;
    if(g_interface.gsm_sms_ind)
        g_interface.gsm_sms_ind(span->span_id, &data);
    
    return 0;
}


